const express = require('express')

module.exports = function (treant) {
  const router = express.Router()

  router.route('/provider')

  // reponse object contains information about oauth provider
  //  - name: name of oauth provider
  //  - url: endpoint for user of oauth provider accept provide access token
  .get(function (req, res) {
    res.json({url: treant.gLoginUrl()})
  })

  // login by code returned from oauth provider
  // redirect to endpoint with access_token and refresh_token in url query
  router.route('/login')
  .get(function (req, res) {
    treant.gLoginCode(req.query.code, function (err, token) {
      if (err) return res.status(500).json({message: err.message})

      res.json({token: token})
    })
  })

  // router.route('/token')
  // .get(function (req, res) {
  //   const accessToken = req.headers['authorization']
  //   tokenRepo.findAccessToken(accessToken, function (errFind, token) {
  //     if (errFind) {
  //       res.status(500).json({
  //         message: 'internal service error. try later'
  //       })
  //       return
  //     }
  //     if (!token) {
  //       res.status(404).json({
  //         message: 'not found refresh token'
  //       })
  //       return
  //     }
  //
  //     oauth.setCredentials({
  //       refresh_token: token.refresh_token
  //     })
  //     oauth.refreshAccessToken(function (errRefesh, tokens) {
  //       if (errRefesh || !tokens) {
  //         res.status(401).json({
  //           message: 'must login to refresh access token'
  //         })
  //         return
  //       }
  //
  //       // save new refresh_token if it is specify
  //       if (tokens.refresh_token) {
  //         tokenRepo.create(accessToken, {
  //           access_token: tokens.accessToken,
  //           expiry_date: tokens.expiry_date,
  //           refresh_token: tokens.refresh_token
  //         }, function () {
  //           // todo: handler here
  //         })
  //       }
  //
  //       res.json({
  //         access_token: tokens.accessToken,
  //         expiry_date: tokens.expiry_date
  //       })
  //     })
  //   })
  // })

  return router
}
