module.exports = function (mongoose, db) {
  var Schema = mongoose.Schema

  // data schema
  var SchedulerModel = new Schema({
    id: String,

    // <string>, object id of author in account
    author: String,

    // <string>, 32 characters, identity
    name: String,

    // array<object>
    //  - start: <string> format by 'hh:ss', 24 hours format
    //  - action: <string>, 32 characters
    tasks: Array,

    // array<string>, 16 characters
    tags: Array,

    // <string>, 1024 characters
    // descriptions of scheduler
    // give information of scheduler to user
    notes: String
  })

  db.model('scheduler', SchedulerModel)
}
